---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: prometheus
  namespace: "{{ meta.namespace }}"
  annotations:
    serviceaccounts.openshift.io/oauth-redirectreference.prometheus: '{"kind":"OAuthRedirectReference","apiVersion":"v1","reference":{"kind":"Route","name":"prometheus"}}'
    serviceaccounts.openshift.io/oauth-redirectreference.alerts: '{"kind":"OAuthRedirectReference","apiVersion":"v1","reference":{"kind":"Route","name":"prometheus-alerts"}}'
---
apiVersion: authorization.openshift.io/v1
kind: Role
metadata:
  name: prometheus-view
  namespace: "{{ meta.namespace }}"
rules:
- apiGroups:
  - ""
  resources:
  - nodes
  - services
  - endpoints
  - pods
  verbs:
  - get
  - list
  - watch
- apiGroups:
  - ""
  resources:
  - configmaps
  verbs:
  - get
---
apiVersion: authorization.openshift.io/v1
kind: RoleBinding
metadata:
  name: prometheus
  namespace: "{{ meta.namespace }}"
roleRef:
  name: prometheus-view
  apiGroup: rbac.authorization.k8s.io
  namespace: "{{ meta.namespace }}"
subjects:
  - kind: ServiceAccount
    name: prometheus
    namespace: "{{ meta.namespace }}"

# Create a fully end-to-end TLS connection to the prometheus proxy
---
apiVersion: route.openshift.io/v1
kind: Route
metadata:
  name: prometheus
  namespace: "{{ meta.namespace }}"
spec:
  to:
    name: prometheus
  tls:
    termination: Reencrypt
    insecureEdgeTerminationPolicy: Redirect
---
apiVersion: v1
kind: Service
metadata:
  namespace: "{{ meta.namespace }}"
  annotations:
    prometheus.io/scrape: "true"
    prometheus.io/scheme: https
    service.alpha.openshift.io/serving-cert-secret-name: prometheus-tls
  labels:
    name: prometheus
  name: prometheus
spec:
  ports:
  - name: prometheus
    port: 443
    protocol: TCP
    targetPort: 8443
  selector:
    app: prometheus
---
apiVersion: v1
kind: Secret
metadata:
  name: prometheus-proxy
  namespace: "{{ meta.namespace }}"
stringData:
  session_secret: "{{ SESSION_SECRET }}"
---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  labels:
    app: prometheus
  name: prometheus
  namespace: "{{ meta.namespace }}"
spec:
  updateStrategy:
    type: RollingUpdate
  podManagementPolicy: Parallel
  selector:
    matchLabels:
      app: prometheus
  template:
    metadata:
      labels:
        app: prometheus
      name: prometheus
    spec:
      serviceAccountName: prometheus
      containers:
      # Deploy Prometheus behind an oauth proxy
      - name: prometheus-proxy
        image: openshift/oauth-proxy:v1.0.0
        imagePullPolicy: IfNotPresent
        ports:
        - containerPort: 8443
          name: web
        env:
        - name: NAMESPACE
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
        args:
        - -provider=openshift
        - -https-address=:8443
        - -http-address=
        - -email-domain=*
        - -upstream=http://localhost:9090
        - -client-id=system:serviceaccount:$(NAMESPACE):prometheus
        - -openshift-ca=/etc/pki/tls/cert.pem
        - -openshift-ca=/var/run/secrets/kubernetes.io/serviceaccount/ca.crt
        - '-openshift-sar={"resource": "namespaces", "verb": "get", "resourceName": "$(NAMESPACE)", "namespace": "$(NAMESPACE)"}'
        - -tls-cert=/etc/tls/private/tls.crt
        - -tls-key=/etc/tls/private/tls.key
        - -client-secret-file=/var/run/secrets/kubernetes.io/serviceaccount/token
        - -cookie-secret-file=/etc/proxy/secrets/session_secret
        - -skip-auth-regex=^
        volumeMounts:
        - mountPath: /etc/tls/private
          name: prometheus-tls
        - mountPath: /etc/proxy/secrets
          name: prometheus-secrets
        - mountPath: /prometheus
          name: prometheus-data

      - name: prometheus
        args:
        - --storage.tsdb.retention=6h
        - --config.file=/etc/prometheus/prometheus.yml
        - --web.listen-address=localhost:9090
        image: openshift/prometheus:v2.3.2
        imagePullPolicy: IfNotPresent
        volumeMounts:
        - mountPath: /etc/prometheus
          name: prometheus-config
        - mountPath: /prometheus
          name: prometheus-data

      # Deploy alertmanager behind an oauth proxy
      # use http port=4190 and https port=9943 to differ from prom-proxy
      - name: alerts-proxy
        image: openshift/oauth-proxy:v1.0.0
        imagePullPolicy: IfNotPresent
        ports:
        - containerPort: 9443
          name: web
        env:
        - name: NAMESPACE
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
        args:
        - -provider=openshift
        - -https-address=:9443
        - -http-address=
        - -email-domain=*
        - -upstream=http://localhost:9099
        - -client-id=system:serviceaccount:$(NAMESPACE):prometheus
        - -openshift-ca=/etc/pki/tls/cert.pem
        - -openshift-ca=/var/run/secrets/kubernetes.io/serviceaccount/ca.crt
        - '-openshift-sar={"resource": "namespaces", "verb": "get", "resourceName": "$(NAMESPACE)", "namespace": "$(NAMESPACE)"}'
        - -tls-cert=/etc/tls/private/tls.crt
        - -tls-key=/etc/tls/private/tls.key
        - -client-secret-file=/var/run/secrets/kubernetes.io/serviceaccount/token
        - -cookie-secret-file=/etc/proxy/secrets/session_secret
        volumeMounts:
        - mountPath: /etc/tls/private
          name: alerts-tls
        - mountPath: /etc/proxy/secrets
          name: alerts-secrets

      - name: alertmanager
        args:
        - --config.file=/etc/alertmanager/alertmanager.yml
        image: openshift/prometheus-alertmanager:v0.15.1
        imagePullPolicy: IfNotPresent
        ports:
        - containerPort: 9093
          name: web
        volumeMounts:
        - mountPath: /etc/alertmanager
          name: alertmanager-config
        - mountPath: /alertmanager
          name: alertmanager-data

      restartPolicy: Always
      volumes:
      - name: prometheus-config
        configMap:
          defaultMode: 420
          name: prometheus
      - name: prometheus-secrets
        secret:
          secretName: prometheus-proxy
      - name: prometheus-tls
        secret:
          secretName: prometheus-tls
      - name: prometheus-data
        emptyDir: {}
      - name: alertmanager-config
        configMap:
            defaultMode: 420
            name: alertmanager
      - name: alerts-secrets
        secret:
          secretName: prometheus-alerts-proxy
      - name: alerts-tls
        secret:
          secretName: prometheus-alerts-tls
      - name: alertmanager-data
        emptyDir: {}

# Create a fully end-to-end TLS connection to the alert proxy
---
apiVersion: route.openshift.io/v1
kind: Route
metadata:
  name: prometheus-alerts
  namespace: "{{ meta.namespace }}"
spec:
  to:
    name: prometheus-alerts
  tls:
    termination: Reencrypt
    insecureEdgeTerminationPolicy: Redirect
---
apiVersion: v1
kind: Service
metadata:
  annotations:
    service.alpha.openshift.io/serving-cert-secret-name: prometheus-alerts-tls
  labels:
    name: prometheus-alerts
  name: prometheus-alerts
  namespace: "{{ meta.namespace }}"
spec:
  ports:
  - name: alerts
    port: 443
    protocol: TCP
    targetPort: 9443
  selector:
    app: prometheus
---
apiVersion: v1
kind: Secret
metadata:
  name: prometheus-alerts-proxy
  namespace: "{{ meta.namespace }}"
stringData:
  session_secret: "{{ SESSION_SECRET }}"

---
apiVersion: v1
kind: ConfigMap
metadata:
  name: prometheus
  namespace: "{{ meta.namespace }}"
data:
  alerting.rules: |
    groups:
    - name: example-rules
      interval: 30s # defaults to global interval
      rules:
      - alert: Node Down
        expr: up{job="kubernetes-nodes"} == 0
        annotations:
          miqTarget: "ContainerNode"
          severity: "HIGH"
          message: "{{ "{{" }}$labels.instance {{ "}}" }} is down"

  recording.rules: |
    groups:
    - name: aggregate_container_resources
      rules:
      - record: container_cpu_usage_rate
        expr: sum without (cpu) (rate(container_cpu_usage_seconds_total[5m]))
      - record: container_memory_rss_by_type
        expr: container_memory_rss{id=~"/|/system.slice|/kubepods.slice"} > 0
      - record: container_cpu_usage_percent_by_host
        expr: sum(rate(container_cpu_usage_seconds_total{id="/"}[5m])) BY(kubernetes_io_hostname) / ON(kubernetes_io_hostname) machine_cpu_cores
      - record: apiserver_request_count_rate_by_resources
        expr: sum without (client,instance,contentType) (rate(apiserver_request_count[5m]))

  prometheus.yml: |
    rule_files:
      - '*.rules'

    scrape_configs:
    # Scrape job to dynamically identify and pull metrics from services
    # deployed in the current namespace.
    #
    # In order to opt into having metrics scraped, a service must be
    # configured with the following annotations (not labels):
    #
    # * `prometheus.io/scrape`: Only scrape services that have a value of `true`
    # * `prometheus.io/scheme`: If the metrics endpoint is secured then you will need
    #    to set this to `https` & most likely set the `tls_config` of the scrape config.
    # * `prometheus.io/path`: If the metrics path is not `/metrics` override this.
    # * `prometheus.io/port`: If the metrics are exposed on a different port to the
    #    service then set this appropriately.
    - job_name: 'kubernetes-service-endpoints'
      tls_config:
        ca_file: /var/run/secrets/kubernetes.io/serviceaccount/ca.crt
        # TODO: this should be per target
        insecure_skip_verify: true
      kubernetes_sd_configs:
      - role: endpoints
        namespaces:
          names:
          - "{{ meta.namespace }}"
      relabel_configs:
        - source_labels: [__meta_kubernetes_service_annotation_prometheus_io_scrape]
          action: keep
          regex: true
        - source_labels: [__meta_kubernetes_service_annotation_prometheus_io_scheme]
          action: replace
          target_label: __scheme__
          regex: (https?)
        - source_labels: [__meta_kubernetes_service_annotation_prometheus_io_path]
          action: replace
          target_label: __metrics_path__
          regex: (.+)
        - source_labels: [__address__, __meta_kubernetes_service_annotation_prometheus_io_port]
          action: replace
          target_label: __address__
          regex: (.+)(?::\d+);(\d+)
          replacement: $1:$2
        - action: labelmap
          regex: __meta_kubernetes_service_label_(.+)
        - source_labels: [__meta_kubernetes_namespace]
          action: replace
          target_label: kubernetes_namespace
        - source_labels: [__meta_kubernetes_service_name]
          action: replace
          target_label: kubernetes_name

      # Job to scrape metrics from all OpenShift pods
    - job_name: 'kubernetes-pods'
      kubernetes_sd_configs:
        - role: pod
          namespaces:
            names:
            - "{{ meta.namespace }}"
      relabel_configs:
        - action: labelmap
          regex: __meta_kubernetes_pod_label_(.+)
        - source_labels: [__meta_kubernetes_namespace]
          action: replace
          target_label: kubernetes_namespace
        - source_labels: [__meta_kubernetes_pod_name]
          action: replace
          target_label: kubernetes_pod_name

      # Job to scrape metrics from all Spark pods
    - job_name: 'Spark Metrics'
      honor_labels: true
      kubernetes_sd_configs:
        - role: pod
          namespaces:
            names:
              - "{{ meta.namespace }}"
      relabel_configs:
        - source_labels: [__meta_kubernetes_pod_name]
          regex: ^.*(spark).*$
          target_label: kubernetes_pod_name
          action: keep
        - source_labels: [__address__]
          regex: (.+):(\d+)
          target_label: __address__
          replacement: ${1}:7777

    {% if ENABLE_PUSHGATEWAY %}
      # Job to scrape metrics from the pushgateway
    - job_name: 'pushgateway'
      honor_labels: true

      kubernetes_sd_configs:
        - role: service

      relabel_configs:
        - source_labels: [__meta_kubernetes_service_annotation_prometheus_io_probe]
          action: keep
          regex: "pushgateway"
        - source_labels: [__meta_kubernetes_service_annotation_prometheus_io_scrape]
          action: keep
          regex: true
        - action: labelmap
          regex: __meta_kubernetes_node_label_(.+)
        - source_labels: [__name__]
          action: replace
          regex: (.+):(?:\d+);(\d+)
          replacement: ${1}:${2}
          target_label: __address__
    {% endif %}

    alerting:
      alertmanagers:
      - scheme: http
        static_configs:
        - targets:
          - "localhost:9093"

---
apiVersion: v1
kind: ConfigMap
metadata:
  name: alertmanager
  namespace: "{{ meta.namespace }}"
data:
  alertmanager.yml: |
    global:

    # The root route on which each incoming alert enters.
    route:
      # default route if none match
      receiver: alert-buffer-wh

      # The labels by which incoming alerts are grouped together. For example,
      # multiple alerts coming in for cluster=A and alertname=LatencyHigh would
      # be batched into a single group.
      # TODO:
      group_by: []

      # All the above attributes are inherited by all child routes and can
      # overwritten on each.

    receivers:
    - name: alert-buffer-wh
      webhook_configs:
      - url: http://localhost:9099/topics/alerts
